/**
 * Write a description of class ArrayDemo here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ArrayDemo
{
    /**
     * Find the smallest element in an array
     *
     * @param  nums  the array of integers
     * @return       the smallest element of nums
     */
    int minElement(int[] nums)
    {
        int smallestSoFar = nums[0];

        for (int i = 1; i < nums.length; i++)
        {
            int n = nums[i];
            if (n < smallestSoFar)
                smallestSoFar = n;
        }
        return smallestSoFar;
    }

    /**
     * Sorts an array by the "selection sort" method.
     * Find the position of the smallest element in the array,
     * swap it with the next unsorted element
     *
     * @param  a   the array to sort
     */
    public static void bubbleSort(int[] a)
    {
        boolean sorted = false;

        while (! sorted)
        {
            sorted = true;
            for (int i = 0; i < a.length - 1; i++)
            {
                if (a[i] > a[i+1])
                {
                    int tmp = a[i];
                    a[i] = a[i+1];
                    a[i+1] = tmp;
                    sorted = false;
                }
            }
        }
    }

    /**
     * An example of a method - replace this comment with your own
     *
     * @param  y   a sample parameter for a method
     * @return     the sum of x and y
     */
    public void printArray(int[] nums)
    {
        for (int n: nums)
            System.out.print(n + " ");
        System.out.println();
    }

    void demo()
    {
        int[] test = {5, 2, 7, 9, 4, 6, 8};
        int smallest = minElement(test);
        System.out.println("Smallest element is: " + smallest);
        bubbleSort(test);
        printArray(test);
    }
}
